/*$Id: d_cccs.cc,v 14.19 1999/08/18 17:17:11 al Exp $ -*- C++ -*-
 * functions for cccs
 * It is really voltage controlled, taking into account the sense element.
 * Then adjust the gain to account for the sense element.
 */
#include "d_cccs.h"
/*--------------------------------------------------------------------------*/
//	void	DEV_CCCS::expand();
// 	bool	DEV_CCCS::do_tr();
// 	void	DEV_CCCS::do_ac();
/*--------------------------------------------------------------------------*/
void DEV_CCCS::expand()
{
  {if (!_input_label.empty()){
    _input = dynamic_cast<ELEMENT*>(find_in_scope(_input_label));
  }else{
    // _input already set, an internal element.  example: mutual L.
  }}
  if (!_input){
    untested();
    error(bERROR, long_label() + ": " + _input_label
	  + " cannot be used as current probe\n");
  }
  assert(_input);
  {if (_input->is_2port()){
    n[IN1] = _input->n[IN1];
    n[IN2] = _input->n[IN2];
  }else{
    assert(_input->is_1port()  ||  _input->is_source());
    n[IN1] = _input->n[OUT1];
    n[IN2] = _input->n[OUT2];
  }}
  n[IN1].e = n[IN2].e = INVALIDNODE;
  assert(loss == 0.);
  m0.c1 = y0.f1 = value();
  y0.f0 = LINEAR;
  m0.c0 = 0.;
  acg = ev = value();
  set_converged();
  assert(!constant()); /* because of incomplete analysis */
}
/*--------------------------------------------------------------------------*/
bool DEV_CCCS::do_tr()
{
  assert(!is_bypassed());
  m0.x = n[IN1].v0() - n[IN2].v0();
  y0.x = _input->tr_amps();
  {if (has_tr_eval()){
    tr_eval();
    m0.c0 = y0.f0 - y0.x * y0.f1;
  }else{
    assert(converged());
    y0.f1 = value();
    y0.f0 = y0.x * y0.f1;
    m0.c0 = 0.;
  }}
  m0.c0 += y0.f1 * _input->m0.c0;
  m0.c1  = y0.f1 * (_input->loss + _input->m0.c1);
  store_values();
  SIM::loadq.push(this);
  return converged();
}
/*--------------------------------------------------------------------------*/
void DEV_CCCS::do_ac()
{
  if (!_input->evaluated()){	/* patch for forward reference */
    _input->do_ac();		/* make sure sense elt is evaluated first */
  }
  {if (has_ac_eval()){
    acbias = n[IN1].vdc() - n[IN2].vdc();
    ac_eval();
  }else{
    ev  = y0.f1;
  }}
  {if (_input->is_source()){	/* if the sense elt is a fixed source.. */
    acg = ev * _input->acg;	/* then part of this one can be modeled */
    ac_load_source();		/* as a fixed source. ...		*/
    acg = ev * _input->loss;	/* so load it in 2 pieces		*/
    ac_load_active();
  }else{
    acg = ev * _input->acg;
    ac_load_active();
  }}
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
